//
//  UMDiameterApplicationId.h
//  ulibdiameter
//
//  Created by Andreas Fink on 27.05.19.
//  Copyright © 2019 Andreas Fink. All rights reserved.
//

/* see also https://www.iana.org/assignments/aaa-parameters/aaa-parameters.xml */
#import <Foundation/Foundation.h>

NSString *umdiameter_application_id_string(uint32_t ai);

typedef enum UMDiameterApplicationId
{
    UMDiameterApplicationId_Diameter_Common_Messages = 0,
    UMDiameterApplicationId_Diameter_Base_Accounting = 3,
    UMDiameterApplicationId_3GPP_Cx = 16777216,
    UMDiameterApplicationId_3GPP_Sh = 16777217,
    UMDiameterApplicationId_3GPP_Re = 16777218,
    UMDiameterApplicationId_3GPP_Wx = 16777219,
    UMDiameterApplicationId_3GPP_Zn = 16777220,
    UMDiameterApplicationId_3GPP_Zh = 16777221,
    UMDiameterApplicationId_3GPP_Gq = 16777222,
    UMDiameterApplicationId_3GPP_Gmb = 16777223,
    UMDiameterApplicationId_3GPP_Gx = 16777224,
    UMDiameterApplicationId_3GPP_Gx2 = 16777238,
    UMDiameterApplicationId_3GPP_Gx_over_Gy = 16777225,
    UMDiameterApplicationId_3GPP_MM10 = 16777226,
    UMDiameterApplicationId_Ericsson_MSI = 16777227,
    UMDiameterApplicationId_Ericsson_Zx = 16777228,
    UMDiameterApplicationId_3GPP_Rx = 16777229,
    UMDiameterApplicationId_3GPP_Rx2 = 16777236,
    UMDiameterApplicationId_3GPP_Pr = 16777230,
    UMDiameterApplicationId_ETSI_e4 = 16777231,
    UMDiameterApplicationId_Ericsson_Charging_CIP = 16777232,
    UMDiameterApplicationId_Ericsson_Mm = 16777233,
    UMDiameterApplicationId_Vodafone_Gx_plus = 16777234,
    UMDiameterApplicationId_ITU_T_Rs = 16777235,
    UMDiameterApplicationId_3GPP2_Ty = 16777237,
    UMDiameterApplicationId_Juniper_Cluster = 16777239,
    UMDiameterApplicationId_Juniper_Policy_Control_AAA = 16777240,
    UMDiameterApplicationId_iptego_USPI = 16777241,
    UMDiameterApplicationId_Covergence_specific_SIP_routing = 16777242,
    UMDiameterApplicationId_Policy_Processing = 16777243,
    UMDiameterApplicationId_Juniper_Policy_Control_JSRC = 16777244,
    UMDiameterApplicationId_ITU_T_S_TC1 = 16777245,
    UMDiameterApplicationId_NSN_Unified_Charging_Trigger_Function = 16777246,
    UMDiameterApplicationId_3GPP2_CAN_Access_Authentication_and_Authorization = 16777247,
    UMDiameterApplicationId_3GPP2_WLAN_Interworking_Access_Authentication_and_Authorization = 16777248,
    UMDiameterApplicationId_3GPP2_WLAN_Interworking_Accounting                              = 16777249,
    UMDiameterApplicationId_3GPP_Sta                                                        = 16777250,
    UMDiameterApplicationId_3GPP_S6a_S6d                    = 16777251,
    UMDiameterApplicationId_3GPP_S13                        = 16777252,
    UMDiameterApplicationId_ETSI_Re                         = 16777253,
    UMDiameterApplicationId_ETSI_GOCAP                      = 16777254,
    UMDiameterApplicationId_SLg                             = 16777255,
    UMDiameterApplicationId_ITU_T_Rw                        = 16777256,
    UMDiameterApplicationId_ETSI_a4                         = 16777257,
    UMDiameterApplicationId_ITU_T_Rt                        = 16777258,
    UMDiameterApplicationId_CARA                            = 16777259,
    UMDiameterApplicationId_CAMA                            = 16777260,
    UMDiameterApplicationId_Femtocell_extension_EAP         = 16777261,
    UMDiameterApplicationId_ITU_T_Ru                        = 16777262,
    UMDiameterApplicationId_ITU_T_Ng                        = 16777263,
    UMDiameterApplicationId_3GPP_SWm                        = 16777264,
    UMDiameterApplicationId_3GPP_SWx                        = 16777265,
    UMDiameterApplicationId_3GPP_Gxx                        = 16777266,
    UMDiameterApplicationId_3GPP_S9                         = 16777267,
    UMDiameterApplicationId_3GPP_Zpn                        = 16777268,
    UMDiameterApplicationId_Ericsson_HSI                    = 16777269,
    UMDiameterApplicationId_Juniper_Example                 = 16777270,
    UMDiameterApplicationId_ITU_T_Ri                        = 16777271,
    UMDiameterApplicationId_3GPP_S6b                        = 16777272,
    UMDiameterApplicationId_Juniper_JGx                     = 16777273,
    UMDiameterApplicationId_ITU_T_Rd                        = 16777274,
    UMDiameterApplicationId_ADMI_Notification               = 16777275,
    UMDiameterApplicationId_ADMI_Messaging_Interface        = 16777276,
    UMDiameterApplicationId_Peter_Service_VSI               = 16777277,
    UMDiameterApplicationId_ETSI_Rr_request_model           = 16777278,
    UMDiameterApplicationId_ETSI_Rr_delegated_model         = 16777279,
    UMDiameterApplicationId_WIMAX_HRPD_Interworking         = 16777280,
    UMDiameterApplicationId_WiMAX_WNAAADA                   = 16777281,
    UMDiameterApplicationId_WiMAX_WNADA                     = 16777282,
    UMDiameterApplicationId_WiMAX_WM4DA                     = 16777283,
    UMDiameterApplicationId_WiMAX_WM6DA                     = 16777284,
    UMDiameterApplicationId_WiMAX_WDDA                      = 16777285,
    UMDiameterApplicationId_WiMAX_WLAADA                    = 16777286,
    UMDiameterApplicationId_WiMAX_WiMAX_PCC_R3_P            = 16777287,
    UMDiameterApplicationId_WiMAX_WiMAX_PCC_R3_OFC          = 16777288,
    UMDiameterApplicationId_WiMAX_PCC_R3_OFC_PRIME          = 16777289,
    UMDiameterApplicationId_WiMAX_PCC_R3_OC                 = 16777290,
    UMDiameterApplicationId_3GPP_SLh                        = 16777291,
    UMDiameterApplicationId_3GPP_SGmb                       = 16777292,
    UMDiameterApplicationId_CMDI                            = 16777293,
    UMDiameterApplicationId_Camiant_DRMA                    = 16777294,
    UMDiameterApplicationId_PiLTE_Interworking              = 16777295,
    UMDiameterApplicationId_Juniper_Sessions_Recovery       = 16777296,
    UMDiameterApplicationId_Vedicis_LiveProxy               = 16777297,
    UMDiameterApplicationId_Pi_3GPP2_Diameter_Application   = 16777298,
    UMDiameterApplicationId_Sandvine_Rf_plus                = 16777299,
    UMDiameterApplicationId_Subscription_Information        = 16777300,
    UMDiameterApplicationId_Ericsson_Charging_DCIP          = 16777301,
    UMDiameterApplicationId_3GPP_Sy                         = 16777302,
    UMDiameterApplicationId_3GPP_Sd                         = 16777303,
    UMDiameterApplicationId_Ericsson_Sy                     = 16777304,
    UMDiameterApplicationId_HP_DTD                          = 16777305,
    UMDiameterApplicationId_M9                              = 16777306,
    UMDiameterApplicationId_ITU_T_M13                       = 16777307,
    UMDiameterApplicationId_3GPP_S7a                        = 16777308,
    UMDiameterApplicationId_3GPP_Tsp                        = 16777309,
    UMDiameterApplicationId_3GPP_S6m                        = 16777310,
    UMDiameterApplicationId_3GPP_T4                         = 16777311,
    UMDiameterApplicationId_3GPP_S6c                        = 16777312,
    UMDiameterApplicationId_3GPP_SGd                        = 16777313,
    UMDiameterApplicationId_Intrado_SLg                     = 16777314,
    UMDiameterApplicationId_Ericsson_DSC                    = 16777315,
    UMDiameterApplicationId_Verizon_Femto_Loc               = 16777316,
    UMDiameterApplicationId_NSN_Hd                          = 16777317,
    UMDiameterApplicationId_3GPP_S15                        = 16777318,
    UMDiameterApplicationId_3GPP_S9a                        = 16777319,
    UMDiameterApplicationId_3GPP_S9a_2                      = 16777320,
    UMDiameterApplicationId_Gateway_Location_Application    = 16777321,
    UMDiameterApplicationId_Verizon_Session_Recovery        = 16777322,
    UMDiameterApplicationId_3GPP2_M1_Interface              = 16777323,
    UMDiameterApplicationId_MAGIC_CIP                       = 16777324,
    UMDiameterApplicationId_ITU_T_Nc                        = 16777325,
    UMDiameterApplicationId_ITU_T_Ne                        = 16777326,
    UMDiameterApplicationId_Ericsson_Sx                     = 16777327,
    UMDiameterApplicationId_Nokia_Service_Extension         = 16777328,
    UMDiameterApplicationId_Rivada_Xd                       = 16777329,
    UMDiameterApplicationId_Rivada_Xm                       = 16777330,
    UMDiameterApplicationId_Rivada_Xh                       = 16777331,
    UMDiameterApplicationId_Rivada_Xf                       = 16777332,
    UMDiameterApplicationId_Rivada_Xp                       = 16777333,
    UMDiameterApplicationId_Rivada_Xa                       = 16777334,
    UMDiameterApplicationId_3GPP_MB2_C                      = 16777335,
    UMDiameterApplicationId_3GPP_PC4a                       = 16777336,
    UMDiameterApplicationId_3GPP_PC2                        = 16777337,
    UMDiameterApplicationId_Juniper_Domain_Policy           = 16777338,
    UMDiameterApplicationId_Host_Observer                   = 16777339,
    UMDiameterApplicationId_3GPP_PC6_PC7                    = 16777340,
    UMDiameterApplicationId_Nokia_Sdr_Application           = 16777341,
    UMDiameterApplicationId_3GPP_Np                         = 16777342,
    UMDiameterApplicationId_Sandvine_Location_Relay         = 16777343,
    UMDiameterApplicationId_Sandvine_Fairshare              = 16777344,
    UMDiameterApplicationId_3GPP_S6t                        = 16777345,
    UMDiameterApplicationId_3GPP_T6a_T6b                    = 16777346,
    UMDiameterApplicationId_3GPP_Ns                         = 16777347,
    UMDiameterApplicationId_3GPP_Nt                         = 16777348,
    UMDiameterApplicationId_3GPP_St                         = 16777349,
    UMDiameterApplicationId_3GPP_PC2_2                      = 16777350,
    UMDiameterApplicationId_3GPP_Diameter_Data_Management   = 16777351,
    UMDiameterApplicationId_ITU_T_M1                        = 16777352,
    UMDiameterApplicationId_ITU_T_M2                        = 16777353,
    UMDiameterApplicationId_Verizon_NLS_WDS                 = 16777354,
    UMDiameterApplicationId_3GPP_V4                         = 16777355,
    UMDiameterApplicationId_3GPP_V6                         = 16777356,
    UMDiameterApplicationId_OMN_Adapt_Application           = 16777357,
    UMDiameterApplicationId_3GPP_Nta                        = 16777358,
    UMDiameterApplicationId_Ericsson_Charging_SBI_Policy    = 16777359,

    UMDiameterApplicationId_FTS_Routing                     = 33554433, /* 0x2000001 */
    UMDiameterApplicationId_FTS_UMTransport                 = 33554434, /* 0x2000002 */
    UMDiameterApplicationId_FTS_Tracing                     = 33554435, /* 0x2000002 */

} UMDiameterApplicationId;

